<?php
/** 
*
* @package acp
* @version $Id: v3_modules.xml,v 1.4 2007/03/18 18:16:40 kellanved Exp $
* @copyright (c) 2007 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
        exit;
}

/**
* @package acp
*/
class acp_tube
{
	var $u_action;
	var $new_config;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('mods/tube');
		$this->tpl_name = 'acp_tube';

		$mode = request_var('mode', '');
		$action = request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;
		$category_id = request_var('category_id', '');
		$item_id = request_var('item_id', '');

		switch($mode)
		{
			case 'categories':
				switch($action)
				{
					case 'edit':
						$display_vars = array(
							'title'	=> 'TUBE_CATEGORY_EDIT',
							'vars'	=> array(
								'legend1'	=> 'TUBE_CATEGORY_ADD',
								'title'		=> array('lang' => 'TUBE_TITLE',	'validate' => 'string',	'type' => 'text:30:100',	'explain' => false),
								'description'	=> array('lang' => 'TUBE_DESCRIPTION',	'validate' => 'string',	'type' => 'textarea:6:40',	'explain' => false),
								'legend2'	=> 'TUBE_CATEGORY_IMAGE',
								'thumb'		=> array('lang' => 'TUBE_CATEGORY_IMAGE',	'validate' => 'string',	'type' => 'image',	'explain' => false),
								'thumb_upload'	=> array('lang' => 'TUBE_CATEGORY_IMAGE',	'validate' => 'string',	'type' => 'file:30:100',	'explain' => false),
						));
					break;

					case 'add':
						$display_vars = array(
							'title'	=> 'TUBE_CATEGORY_ADD',
							'vars'	=> array(
								'legend1'	=> 'TUBE_CATEGORY_ADD',
								'title'		=> array('lang' => 'TUBE_TITLE',	'validate' => 'string',	'type' => 'text:30:100',	'explain' => false),
								'description'	=> array('lang' => 'TUBE_DESCRIPTION',	'validate' => 'string',	'type' => 'textarea:6:40',	'explain' => false),
								'legend2'	=> 'TUBE_CATEGORY_IMAGE',
								'thumb'		=> array('lang' => 'TUBE_CATEGORY_IMAGE',	'validate' => 'string',	'type' => 'image',	'explain' => false),
								'thumb_upload'	=> array('lang' => 'TUBE_CATEGORY_IMAGE',	'validate' => 'string',	'type' => 'file:30:100',	'explain' => false),
						));
					break;
				}
			break;

			case 'items':
				switch($action)
				{
					case 'edit':
						$display_vars = array(
							'title'	=> 'TUBE_ITEM_EDIT',
							'vars'	=> array(
								'legend1'	=> 'TUBE_ITEM_EDIT',
								'title'		=> array('lang' => 'TUBE_TITLE',	'validate' => 'string',	'type' => 'text:30:100',	'explain' => false),
								'category_id'	=> array('lang' => 'TUBE_CATEGORY',	'validate' => 'string',	'type' => 'select',	'method' => 'category_select',	'explain' => false),
								'description'	=> array('lang' => 'TUBE_DESCRIPTION',	'validate' => 'string',	'type' => 'textarea:6:40',	'explain' => false),
								'legend2'	=> 'TUBE_ITEM_IMAGE',
								'thumb'		=> array('lang' => 'TUBE_ITEM_IMAGE',	'validate' => 'string',	'type' => 'image',	'explain' => false),
						));
					break;
				}
			break;

			case 'index':
			default:
				$display_vars = array(
					'title'	=> 'TUBE_GENERAL',
					'vars'	=> array(
						'legend1'		=> 'TUBE_GENERAL',
						'tube_disabled'		=> array('lang' => 'TUBE_DISABLE',	'validate' => 'bool',	'type' => 'radio:yes_no',	'explain' => false),
						'legend2'		=> 'TUBE_FORMATS',
						'tube_upload_flv' => array('lang' => 'TUBE_UPLOAD_FLV_SUPPORT',      'validate' => 'bool',   'type' => 'radio:yes_no',       'explain' => true),
						'tube_upload'		=> array('lang' => 'TUBE_UPLOAD_SUPPORT',      'validate' => 'bool',   'type' => 'radio:yes_no',       'explain' => true),
						'tube_youtube'		=> array('lang' => 'TUBE_YOUTUBE_SUPPORT',      'validate' => 'bool',   'type' => 'radio:yes_no',       'explain' => true),
						'legend3'		=> 'TUBE_PROGRAMS',
						'tube_system_tmp'	=> array('lang' => 'TUBE_SYSTEM_TMP',	'validate' => 'string',	'type' => 'text:30:100',	'explain' => true),
						'tube_ffmpeg'		=> array('lang' => 'TUBE_FFMPEG',	'validate' => 'string',	'type' => 'text:30:100',	'explain' => true, 'append' => '&nbsp;&nbsp;<span>[ <a href="' . $this->u_action . '&amp;action=ffmpeg">' . $user->lang['TUBE_SEARCH_FFMPEG'] . '</a> ]</span>'),
						'tube_zend'		=> array('lang' => 'TUBE_ZEND',	'validate' => 'string',	'type' => 'text:30:100',	'explain' => true),
				));
			break;
		}
/*
*
* MAIN
*
*/
		switch($mode)
		{
			case 'categories':
				switch($action)
				{
					case 'delete':
						$sql = 'SELECT *
							FROM ' . TUBE_CATEGORIES_TABLE . '
							WHERE category_id = ' . $category_id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						if ($row)
						{
							if (confirm_box(true))
							{
								$sql = 'SELECT *
									FROM ' . TUBE_CATEGORIES_TABLE . '
									WHERE category_id = ' . $category_id;
								$result = $db->sql_query($sql);
								$row = $db->sql_fetchrow($result);
								$db->sql_freeresult($result);
								if (isset($row['thumb']) && $row['thumb'] != '' && file_exists($row['thumb']))
								{
									unlink($row['thumb']);
								}
								$db->sql_query('DELETE FROM ' . TUBE_CATEGORIES_TABLE . ' WHERE category_id = ' . $category_id);
								$cache->destroy('sql', TUBE_CATEGORIES_TABLE);
								add_log('admin', 'LOG_TUBE_CATEGORY_DELETE');
								trigger_error($user->lang['TUBE_CATEGORY_DELETED'] . adm_back_link($this->u_action));
							}
							else
							{
								confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
									'category_id'	=> $category_id,
									'i'		=> $id,
									'mode'		=> $mode,
									'action'	=> $action))
								);
							}
						}
					break;

					case 'edit':
						if ($submit && isset($_REQUEST['config']))
						{
							$image = '';
							$file = $_FILES['config']['tmp_name']['thumb_upload'];
							$file_type = $_FILES['config']['type']['thumb_upload'];
							if (!empty($file))
							{
								$sql = 'SELECT *
									FROM ' . TUBE_CATEGORIES_TABLE . '
									WHERE category_id = ' . $category_id;
								$result = $db->sql_query($sql);
								$row = $db->sql_fetchrow($result);
								$db->sql_freeresult($result);
								if (isset($row['thumb']) && $row['thumb'] != '' && file_exists($row['thumb']))
								{
									unlink($row['thumb']);
								}

								list($usec, $sec) = explode(" ",microtime());
								$filename = $sec.($usec * 100000000);
								$size = GetImageSize($file);
//								$w = $size[0];
//								$h = $size[1];
								$tn_max_width = $tn_max_height = 96;
								$x_ratio = $tn_max_width / $size[0];
								$y_ratio = $tn_max_height / $size[1];
								if (($x_ratio * $size[1]) < $tn_max_height)
								{
									$tn_height = ceil($x_ratio * $size[1]);
									$tn_width = $tn_max_width;
								}
								else
								{
									$tn_width = ceil($y_ratio * $size[0]);
									$tn_height = $tn_max_height;
								}
								switch ($file_type) {
									case 'image/jpeg':
									case 'image/pjpeg':
										$tn_src = ImageCreateFromJPEG($file);
									break;

									case 'image/gif':
										$tn_src = ImageCreateFromGIF($file);
									break;

									case 'image/png':
									case 'image/x-png':
										$tn_src = ImageCreateFromPNG($file);
									break;
								}
								$tn_dst = ImageCreateTruecolor($tn_width,$tn_height);
								ImageCopyResampled($tn_dst, $tn_src, 0, 0, 0, 0, $tn_width,$tn_height,$size[0],$size[1]);
								$image = $phpbb_root_path . 'tube/images/categories/' . $filename . '.png';
								ImagePNG($tn_dst, $image, -1);
								ImageDestroy($tn_src);
								ImageDestroy($tn_dst);
							}
							$data = array(
								'title'		=> $_POST['config']['title'],
								'description'	=> $_POST['config']['description'],
							);
							if (isset($image) && $image != '')
							{
								$data = array_merge($data,array(
									'thumb'	=> $image,
								));
							}
							$db->sql_query('UPDATE ' . TUBE_CATEGORIES_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . ' WHERE category_id = ' . $category_id);
							$cache->destroy('sql', TUBE_CATEGORIES_TABLE);
							add_log('admin', 'LOG_TUBE_CATEGORY_EDIT');
							trigger_error($user->lang['TUBE_CATEGORY_EDITED'] . adm_back_link($this->u_action));
						}
						$sql = 'SELECT *
							FROM ' . TUBE_CATEGORIES_TABLE . '
							WHERE category_id = ' . $category_id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						$this->new_config = $row;
					// No break here as the information is populated into the 'add' case below

					case 'add':
						if ($submit && isset($_REQUEST['config']))
						{
							$image = '';
							$file = $_FILES['config']['tmp_name']['thumb_upload'];
							$file_type = $_FILES['config']['type']['thumb_upload'];
							if (!empty($file))
							{
								list($usec, $sec) = explode(" ",microtime());
								$filename = $sec.($usec * 100000000);
								$size = GetImageSize($file);
								$tn_max_width = $tn_max_height = 96;
								$x_ratio = $tn_max_width / $size[0];
								$y_ratio = $tn_max_height / $size[1];
								if (($x_ratio * $size[1]) < $tn_max_height)
								{
									$tn_height = ceil($x_ratio * $size[1]);
									$tn_width = $tn_max_width;
								}
								else
								{
									$tn_width = ceil($y_ratio * $size[0]);
									$tn_height = $tn_max_height;
								}
								switch ($file_type) {
									case 'image/jpeg':
									case 'image/pjpeg':
										$tn_src = ImageCreateFromJPEG($file);
									break;

									case 'image/gif':
										$tn_src = ImageCreateFromGIF($file);
									break;

									case 'image/png':
									case 'image/x-png':
										$tn_src = ImageCreateFromPNG($file);
									break;
								}
								$tn_dst = ImageCreateTruecolor($tn_width,$tn_height);
								ImageCopyResampled($tn_dst, $tn_src, 0, 0, 0, 0, $tn_width,$tn_height,$size[0],$size[1]);
								$image = $phpbb_root_path . 'tube/images/categories/' . $filename . '.png';
								ImagePNG($tn_dst, $image, -1);
								ImageDestroy($tn_src);
								ImageDestroy($tn_dst);
							}
							$data = array(
								'title'			=> $_POST['config']['title'],
								'description'	=> $_POST['config']['description'],
							);
							if (isset($image) && $image != '')
							{
								$data = array_merge($data,array(
									'thumb'		=> $image,
								));
							}
							$db->sql_query('INSERT INTO ' . TUBE_CATEGORIES_TABLE . $db->sql_build_array('INSERT', $data));
							$cache->destroy('sql', TUBE_CATEGORIES_TABLE);
							add_log('admin', 'LOG_TUBE_CATEGORY_ADD');
							trigger_error($user->lang['TUBE_CATEGORY_ADDED'] . adm_back_link($this->u_action));
						}
						$this->page_title = 'TUBE_CATEGORY_INDEX';
						$template->assign_vars(array(
							'S_DISPLAY_MODE'	=> 'edit',
							'U_ACTION'			=> $this->u_action . '&amp;action=' . $action . '&amp;category_id=' . $category_id,
							'L_TITLE'			=> $user->lang[$display_vars['title']],
							'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN']
						));

						foreach ($display_vars['vars'] as $config_key => $vars)
						{
							if (!is_array($vars) && strpos($config_key, 'legend') === false)
							{
								continue;
							}
							if (strpos($config_key, 'legend') !== false)
							{
								$template->assign_block_vars('options', array(
									'S_LEGEND'	=> true,
									'LEGEND'	=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars,
								));
								continue;
							}
							$type = explode(':', $vars['type']);
							$l_explain = '';
							if ($vars['explain'] && isset($vars['lang_explain']))
							{
								$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
							}
							else if ($vars['explain'])
							{
								$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
							}
							$template->assign_block_vars('options', array(
								'KEY'			=> $config_key,
								'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
								'S_EXPLAIN'		=> $vars['explain'],
								'TITLE_EXPLAIN'	=> $l_explain,
								'CONTENT'		=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
							));
							unset($display_vars['vars'][$config_key]);
						}
					break;

					default:
						$this->page_title = 'TUBE_CATEGORY_INDEX';
						$template->assign_vars(array(
							'S_DISPLAY_MODE'		=> 'category_list',
							'U_ACTION'			=> $this->u_action . '&amp;action=add',
							'L_TITLE'			=> $user->lang['TUBE_CATEGORY_INDEX'],
							'L_TITLE_EXPLAIN'		=> $user->lang['TUBE_CATEGORY_INDEX_EXPLAIN'],
						));

						$sql = 'SELECT *
							FROM ' . TUBE_CATEGORIES_TABLE . '
							ORDER BY title';
						$result = $db->sql_query($sql);
						while ($row = $db->sql_fetchrow($result))
						{
							$template->assign_block_vars('category', array(
								'TITLE'			=> $row['title'],
								'DESCRIPTION'	=> $row['description'],
								'THUMB'			=> $row['thumb'],
								'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;category_id=' . $row['category_id'],
								'U_DELETE'		=> $this->u_action . '&amp;action=delete&amp;category_id=' . $row['category_id'],
							));
						}
						$db->sql_freeresult($result);
					break;
				}
			break;

			case 'items':
				switch($action)
				{
					case 'delete':
						$sql = 'SELECT *
							FROM ' . TUBE_ITEMS_TABLE . "
							WHERE item_id = '" . $item_id . "'";
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						if ($row)
						{
							if (confirm_box(true))
							{
								$thumb = $phpbb_root_path . 'tube/images/no_thumb.png';
								$sql = 'SELECT *
									FROM ' . TUBE_ITEMS_TABLE . "
									WHERE item_id = '" . $item_id . "'";
								$result = $db->sql_query($sql);
								$row = $db->sql_fetchrow($result);
								$db->sql_freeresult($result);
								if (($row['youtube'] == '')&&($row['thumb'] != $thumb))
								{
									if (isset($row['thumb']) && $row['thumb'] != '' && file_exists($row['thumb']))
									{
										unlink($row['thumb']);
									}
									if (isset($row['image']) && $row['image'] != '' && file_exists($row['image']))
									{
										unlink($row['image']);
									}
									if (file_exists($phpbb_root_path . "tube/videos/" . $row['item_id'] . '.flv'))
									{
										unlink($phpbb_root_path . "tube/videos/" . $row['item_id'] . '.flv');
									}
								}
								$db->sql_query('DELETE FROM ' . TUBE_ITEMS_TABLE . " WHERE item_id = '" . $item_id . "'");
								$cache->destroy('sql', TUBE_ITEMS_TABLE);
								$db->sql_query('DELETE FROM ' . TUBE_RATINGS_TABLE . " WHERE item_id = '" . $item_id . "'");
								$cache->destroy('sql', TUBE_RATINGS_TABLE);
								$db->sql_query('DELETE FROM ' . TUBE_COMMENTS_TABLE . " WHERE comment_item_id = '" . $item_id . "'");
								$cache->destroy('sql', TUBE_COMMENTS_TABLE);
								add_log('admin', 'LOG_TUBE_ITEM_DELETE');
								trigger_error($user->lang['TUBE_ITEM_DELETED'] . adm_back_link($this->u_action));
							}
							else
							{
								confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
									'item'				=> $item_id,
									'i'					=> $id,
									'mode'				=> $mode,
									'action'			=> $action))
								);
							}
						}
					break;

					case 'edit':
						if ($submit && isset($_REQUEST['config']))
						{
							$data = array(
								'title'					=> $_POST['config']['title'],
								'category_id'			=> $_POST['config']['category_id'],
								'description'			=> $_POST['config']['description'],
							);
							$db->sql_query('UPDATE ' . TUBE_ITEMS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . " WHERE item_id = '" . $item_id . "'");
							$cache->destroy('sql', TUBE_ITEMS_TABLE);
							add_log('admin', 'LOG_TUBE_ITEM_EDIT');
							trigger_error($user->lang['TUBE_ITEM_EDITED'] . adm_back_link($this->u_action));
						}
						$sql = 'SELECT *
							FROM ' . TUBE_ITEMS_TABLE . "
							WHERE item_id = '" . $item_id . "'";
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						$this->new_config = $row;
					// No break here as the information is populated into the 'add' case below

					case 'add':
						$this->page_title = 'TUBE_CATEGORY_INDEX';
						$template->assign_vars(array(
							'S_DISPLAY_MODE'	=> 'edit',
							'U_ACTION'			=> $this->u_action . '&amp;action=' . $action . '&amp;item_id=' . $item_id,
							'L_TITLE'			=> $user->lang[$display_vars['title']],
							'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
						));

						foreach ($display_vars['vars'] as $config_key => $vars)
						{
							if (!is_array($vars) && strpos($config_key, 'legend') === false)
							{
								continue;
							}
							if (strpos($config_key, 'legend') !== false)
							{
								$template->assign_block_vars('options', array(
									'S_LEGEND'	=> true,
									'LEGEND'	=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars,
								));
								continue;
							}
							$type = explode(':', $vars['type']);
							$l_explain = '';
							if ($vars['explain'] && isset($vars['lang_explain']))
							{
								$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
							}
							else if ($vars['explain'])
							{
								$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
							}
							$template->assign_block_vars('options', array(
								'KEY'			=> $config_key,
								'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
								'S_EXPLAIN'		=> $vars['explain'],
								'TITLE_EXPLAIN'	=> $l_explain,
								'CONTENT'		=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
							));
							unset($display_vars['vars'][$config_key]);
						}
					break;

					default:
						$this->page_title = 'TUBE_ITEM_INDEX';
						$template->assign_vars(array(
							'S_DISPLAY_MODE'	=> 'item_list',
							'U_ACTION'		=> $this->u_action . '&amp;action=add',
							'L_TITLE'		=> $user->lang['TUBE_ITEM_INDEX'],
							'L_TITLE_EXPLAIN'	=> $user->lang['TUBE_ITEM_INDEX_EXPLAIN'],
						));
						$sql = 'SELECT i.*, c.title AS cat
							FROM ' . TUBE_ITEMS_TABLE . ' i, ' . TUBE_CATEGORIES_TABLE . ' c
							WHERE i.category_id = c.category_id
							ORDER BY i.title';
						$result = $db->sql_query($sql);
						while ($row = $db->sql_fetchrow($result))
						{
							$template->assign_block_vars('item', array(
								'TITLE'		=> $row['title'],
								'CATEGORY'	=> $row['cat'],
								'THUMB'		=> $row['thumb'],
								'U_EDIT'	=> $this->u_action . '&amp;action=edit&amp;item_id=' . $row['item_id'],
								'U_DELETE'	=> $this->u_action . '&amp;action=delete&amp;item_id=' . $row['item_id'],
							));
						}
						$db->sql_freeresult($result);
					break;
				}
			break;

			case 'index':
			default:
				$this->new_config = $config;
				$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
				if ($submit)
				{
				/*
					$file = $_FILES['config']['tmp_name']['image_upload'];
					$logo = $phpbb_root_path . 'tube/images/logo.png';
					if ($_FILES['config']['type']['image_upload'] == 'image/png' || $_FILES['config']['type']['image_upload'] == 'image/x-png')
					{
						if (file_exists($logo))
						{
							unlink($logo);
						}
						move_uploaded_file($_FILES['config']['tmp_name']['image_upload'],$logo);
						set_config('tube_logo', $logo);
					}
				*/	
					foreach ($display_vars['vars'] as $config_name => $null)
					{
						if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
						{
							continue;
						}
						$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];
						set_config($config_name, $config_value);
					}
					add_log('admin', 'LOG_TUBE_GENERAL');
					trigger_error($user->lang['TUBE_GENERAL_UPDATED'] . adm_back_link($this->u_action));
				}

				switch($action)
				{
					case 'ffmpeg':
						$this->new_config['tube_ffmpeg'] = $this->search_for('ffmpeg');
					break;
				}

				$this->page_title = 'TUBE_GENERAL';
				$template->assign_vars(array(
					'S_DISPLAY_MODE'	=> 'edit',
					'U_ACTION'		=> $this->u_action . '&amp;action=index',
					'L_TITLE'		=> $user->lang[$display_vars['title']],
					'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
				));
				foreach ($display_vars['vars'] as $config_key => $vars)
				{
					if (!is_array($vars) && strpos($config_key, 'legend') === false)
					{
						continue;
					}
					if (strpos($config_key, 'legend') !== false)
					{
						$template->assign_block_vars('options', array(
							'S_LEGEND'	=> true,
							'LEGEND'	=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars,
						));
						continue;
					}
					$type = explode(':', $vars['type']);
					$l_explain = '';
					if ($vars['explain'] && isset($vars['lang_explain']))
					{
						$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
					}
					else if ($vars['explain'])
					{
						$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
					}
					$template->assign_block_vars('options', array(
						'KEY'		=> $config_key,
						'TITLE'		=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
						'S_EXPLAIN'	=> $vars['explain'],
						'TITLE_EXPLAIN'	=> $l_explain,
						'CONTENT'	=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
					));
					unset($display_vars['vars'][$config_key]);
				}
			break;
		}
	}

	function category_select($value = '')
	{
		global $db;
		$data = '';
		$sql = 'SELECT category_id,title
			FROM ' . TUBE_CATEGORIES_TABLE . '
			ORDER BY title';
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			$data .= '<option value="' . $row['category_id'] . '"' . (($value == $row['category_id']) ? ' selected="selected"' : '') . '>' . $row['title'] . '</option>';
		}
		$db->sql_freeresult($result);
		return $data;
	}

	function search_for($what)
	{
		$result = '';
		$locations = array('/usr/bin/', '/usr/sbin/', '/usr/local/bin/', '/usr/local/sbin/', '/opt/');
		$path_locations = str_replace('\\', '/', (explode(':', getenv('PATH'))));
		$locations = array_merge($path_locations, $locations);
		foreach ($locations as $location)
		{
			// The path might not end properly, fudge it
			if (substr($location, -1) !== '/')
			{
				$location .= '/';
			}

			if (@file_exists($location . $what) && @is_readable($location . $what))
			{
				$result = str_replace('\\', '/', $location . $what);
				continue;
			}
		}

		return $result;
	}
	
	//Check if a thumbnail exists
	function thumbnail_check()
	{
		$sql = 'SELECT * FROM ' . TUBE_ITEMS_TABLE;
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$thumb_path = '/images/' . $row[thumb];
			if (file_exists(thumb_path) == FALSE)
			{
				$data = array(
					'thumb'			=> 'no_thumb.png',
				);

				$db->sql_query('UPDATE ' . TUBE_ITEMS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . " WHERE item_id = '" . $row[item_id] . "'");
				$cache->destroy('sql', TUBE_ITEMS_TABLE);
			}
		}

		$db->sql_freeresult($result);
	}
}
?>
