<?php
/**
*
* @author Username (Joe Smith) joesmith@example.org
* @package umil
* @copyright (c) 2008 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);

@define('DEBUG', true);
@define('DEBUG_EXTRA', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'OurTube';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'tube_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
* $mod_name
* 'INSTALL_' . $mod_name
* 'INSTALL_' . $mod_name . '_CONFIRM'
* 'UPDATE_' . $mod_name
* 'UPDATE_' . $mod_name . '_CONFIRM'
* 'UNINSTALL_' . $mod_name
* 'UNINSTALL_' . $mod_name . '_CONFIRM'
*/
$language_file = 'mods/tube_install';

/*
* Options to display to the user (this is purely optional, if you do not need the options you do not have to set up this variable at all)
* Uses the acp_board style of outputting information, with some extras (such as the 'default' and 'select_user' options)

$options = array(
	'test_username'	=> array('lang' => 'TEST_USERNAME', 'type' => 'text:40:255', 'explain' => true, 'default' => $user->data['username'], 'select_user' => true),
	'test_boolean'	=> array('lang' => 'TEST_BOOLEAN', 'type' => 'radio:yes_no', 'default' => true),
);

* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
//$logo_img = 'styles/prosilver/imageset/site_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	// Version 2.1.0
	'2.1.0'	=> array(
		// Create items table.
		'table_add' => array(
			array('phpbb_tube_categories', array(
					'COLUMNS'		=> array(
						'category_id' => array('INT:5', NULL, 'auto_increment'),
						'title' => array('VCHAR:200', ''),
						'description' => array('MTEXT', ''),
						'thumb' => array('VCHAR:200', ''),
					),
					'PRIMARY_KEY'	=> 'category_id',
				),
			),
			array('phpbb_tube_items', array(
					'COLUMNS'		=> array(
						'item_id' => array('VCHAR:32', ''),
						'title' => array('VCHAR:200', ''),
						'category_id' => array('INT:5', 0),
						'description' => array('MTEXT', ''),
						'user_id' => array('INT:11', 0),
						'views' => array('INT:5', 0),
						'duration' => array('INT:5', 0),
						'date' => array('INT:10', 0),
						'thumb' => array('VCHAR:200', ''),
						'image' => array('VCHAR:200', ''),
						'youtube' => array('VCHAR:200', ''),
					),
					'PRIMARY_KEY'	=> 'item_id',
				),
			),
			array('phpbb_tube_ratings', array(
					'COLUMNS'		=> array(
						'rating_id' => array('INT:8', NULL, 'auto_increment'),
						'item_id' => array('VCHAR:32', ''),
						'user_id' => array('INT:11', 0),
						'rating' => array('INT:1', 0),
					),
					'PRIMARY_KEY'	=> 'rating_id',
				),
			),
			array('phpbb_tube_comments', array(
					'COLUMNS'		=> array(
						'comment_id' => array('INT:8', NULL, 'auto_increment'),
						'comment_item_id' => array('VCHAR:32', ''),
						'comment_user_id' => array('INT:8', 0),
						'comment_username' => array('VCHAR:255', ''),
						'comment_user_ip' => array('VCHAR:40', ''),
						'comment_time' => array('INT:11', 0),
						'comment' => array('MTEXT', ''),
						'comment_uid' => array('VCHAR:8', ''),
						'comment_bitfield' => array('VCHAR:255', ''),
						'comment_options' => array('INT:11', 7),
						'comment_edit_time' => array('INT:11', 0),
						'comment_edit_count' => array('INT:4', 0),
						'comment_edit_user_id' => array('INT:8', 0),
					),
					'PRIMARY_KEY'	=> 'comment_id',
				),
			),
		),
		
		// Lets add a config setting named test_enable and set it to true
		'config_add' => array(
			array('tube_disabled', 1, true),
			array('tube_upload', 0, true),
			array('tube_youtube', 0, true),
			array('tube_logo', '', true),
			array('tube_logo_enabled', 0, true),
			array('tube_ffmpeg', '', true),
			array('tube_mencoder', '', true),
			array('tube_flvtool', '', true),
			array('tube_system_tmp', 'tube/tmp', true),
			array('tube_zend', 'tube/zend', true),
			array('tube_comment_length', 1000, true),
		),
		
		// Now to add some permission settings
		'permission_add' => array(
			array('u_tube_view', true),
			array('u_tube_add', true),
			array('m_tube_delete', true),
			array('m_tube_edit', true),
		),

		// How about we give some default permissions then as well?
		'permission_set' => array(
			// Global Role permissions
			array('ROLE_ADMIN_FULL', 'u_tube_view'),
			array('ROLE_ADMIN_FULL', 'u_tube_add'),
			array('ROLE_USER_FULL', 'u_tube_view'),
		),
		
         // Add ACP modules
         'module_add' => array(
            array('acp', 'ACP_CAT_DOT_MODS', 'ACP_TUBE'), // your main tube category
            array('acp', 'ACP_TUBE', array(
                  'module_basename'   => 'tube',
                  'module_langname'   => 'ACP_TUBE_INDEX',
                  'module_mode'       => 'index',
                  'module_auth'       => 'acl_a_board',
             )),
             array('acp', 'ACP_TUBE', array(
                  'module_basename'   => 'tube',
                  'module_langname'   => 'ACP_TUBE_CATEGORIES',
                  'module_mode'       => 'categories',
                  'module_auth'       => 'acl_a_board',
             )),
             array('acp', 'ACP_TUBE', array(
                  'module_basename'   => 'tube',
                  'module_langname'   => 'ACP_TUBE_ITEMS',
                  'module_mode'       => 'items',
                  'module_auth'       => 'acl_a_board',
             )),
          ),
			
	),
	
	'2.1.1'	=> array(
        'config_remove' => array(
			array('tube_mencoder'),
			array('tube_flvtool'),
		),
	),


);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>