<?php

//Count the items of a category
function countItems($category_id)
{
	global $db;

	$sql = 'SELECT COUNT(*) as num_items
		FROM ' . TUBE_ITEMS_TABLE . '
		WHERE category_id = ' . $category_id;
	$result = $db->sql_query($sql);
	$total_items = $db->sql_fetchfield('num_items');
	$db->sql_freeresult($result);

	return $total_items;
}
// Get user info
function get_user_info($uid)
{
	global $db;

	$sql = 'SELECT * FROM ' . USERS_TABLE . '
		WHERE user_id = ' . $uid;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row;
}
// Get icon for upload option
function get_uploadoption_img($item_id)
{
	global $phpbb_root_path, $user;

	$item_info = get_item_info($item_id);
	$icon_img = ($item_info['youtube'] != '') ? 'icon_youtube.png' : 'icon_ourtube.gif';

	return '<img src=' . $phpbb_root_path . 'styles/' . $user->theme['template_path'] . '/theme/images/' .$icon_img . ' alt=' . $icon_img . ' />';
}
// Get item info
function get_item_info($item_id)
{
	global $db, $phpEx;

	$sql = 'SELECT * FROM ' . TUBE_ITEMS_TABLE . "
		WHERE item_id = '" . $db->sql_escape($item_id) . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	/* 2.1
	if (!$row)
	{
	    meta_refresh(3, append_sid("{$phpbb_root_path}{$tube_path}index.$phpEx"));	
		trigger_error('VIDEO_NOT_EXIST');
	}
	*/
	return $row;
}
// Count the comments of an item
function countComments($item_id)
{
	global $db;

	$sql = 'SELECT COUNT(*) as num_comments
		FROM ' . TUBE_COMMENTS_TABLE . "
		WHERE comment_item_id ='" . $db->sql_escape($item_id) . "'";
	$result = $db->sql_query($sql);
	$num_comments = $db->sql_fetchfield('num_comments');
	$db->sql_freeresult($result);

	return $num_comments;
}
function make_tabs($category = 0)
{
	$num_tabs = 3;
	get_tabitems_order($category,0,$num_tabs,'newest','date DESC');
	get_tabitems_order($category,0,$num_tabs,'rated','rating DESC');
	get_tabitems_order($category,0,$num_tabs,'viewed','views DESC');
}

// Get the ordered items for the tab
function get_tabitems_order($category,$start,$limit,$block_var,$sort_order)
{
	global $phpbb_root_path, $tube_path, $user, $db, $template, $phpEx;

	$x = $y = 0;

	if ($block_var == 'rated')
	{
		$sql_array['SELECT'] = 'i.*, (SUM(r.rating)/COUNT(r.item_id)) AS rating';
		$sql_array['FROM'] = array( TUBE_ITEMS_TABLE => 'i', );
		$sql_array['LEFT_JOIN'] = array( array( 'FROM' => array( TUBE_RATINGS_TABLE => 'r' ), 'ON' => 'i.item_id = r.item_id' ) );
		($category > 0) ? $sql_array['WHERE'] = "rating <> 0 AND category_id = '" . $db->sql_escape($category) . "'" : $sql_array['WHERE']	= 'rating <> 0';
		$sql_array['GROUP_BY'] = 'i.item_id';
		$sql_array['ORDER_BY'] = $sort_order;
		$sql = $db->sql_build_query('SELECT', $sql_array);
	}
	else
	{
		if ($category > 0)
		{
			$sql = 'SELECT * FROM ' . TUBE_ITEMS_TABLE . "
				WHERE category_id = '" . $db->sql_escape($category) . "'
				ORDER BY $sort_order";
		}
		else
		{
			$sql = 'SELECT *
				FROM ' . TUBE_ITEMS_TABLE . "
				WHERE 1
				ORDER BY $sort_order";
		}
	}
	$result = $db->sql_query_limit($sql, $limit, $start);

	while ($row = $db->sql_fetchrow($result))
	{
		$x++;
		$y++;
		$user_info = get_user_info($row['user_id']);
		$template->assign_block_vars($block_var, array(
			'S_ROW'				=> $x % 3,
			'S_COL'				=> $y,
			'U_ITEM'			=> append_sid("{$tube_path}video.$phpEx", "mode=item&amp;id=" . $row['item_id']),
			'ITEM'				=> $row['title'],
			'DESCRIPTION'		=> (strlen($row['description']) > 30) ? substr($row['description'], 0, 30) . '...' : $row['description'],
			'THUMB'				=> ($row['youtube'] != '') ? $row['thumb'] : append_sid($row['thumb']),
			'USER'				=> get_username_string('full', $row['user_id'], $user_info['username'], $user_info['user_colour']),
			'VIEWS'				=> $row['views'],
			'COMMENTS'			=> countComments($row['item_id']),
			'UPLOAD_OPTION'		=> get_uploadoption_img($row['item_id']),
			'DURATION'			=> str_pad(intval(($row['duration'] / 60) % 60), 2, "0", STR_PAD_LEFT) . ':' . str_pad(intval($row['duration'] % 60), 2, "0", STR_PAD_LEFT),
		));
	}
	$db->sql_freeresult($result);
}
?>