<?php
/**
*
* @package phpBB3
* @version $Id: video.php
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './../';
$tube_path = $phpbb_root_path . 'tube/';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);

include($tube_path . 'tube_functions.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/tube');

// Setup specific vars
$mode = request_var('mode','');
$submode = request_var('submode','');
$type = request_var('type','');
$id = request_var('id','');
$start = request_var('start',0);
$submit = (isset($_POST['submit'])) ? true : false;
$deny = (isset($_POST['deny'])) ? true : false;
$item_id = request_var('item_id',0);
$comment_id = request_var('comment_id',0);
$sort_order = request_var('sort_order','DESC');
$error = $message = NULL;
$comment = $comment_username = '';
$comment_limit = 5;
$chrs = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S' ,'T', 'U', 'V', 'W', 'X', 'Y', 'Z');

// Vars for the editor
$bbcode_status	= ($config['allow_bbcode']) ? true : false;
$smilies_status	= ($config['allow_smilies']) ? true : false;
$img_status		= ($bbcode_status) ? true : false;
$url_status		= ($config['allow_post_links']) ? true : false;
$flash_status	= false;
$quote_status	= true;
if($bbcode_status)
{
	$user->add_lang('posting');
	display_custom_bbcodes();
}
if($smilies_status)
{
	generate_smilies('inline', 0);
}

$template->assign_vars(array(
    'S_TUBE_ADD'			=> ($auth->acl_get('u_tube_add') && (($config['tube_upload'] == true && $config['tube_ffmpeg'] != '' && is_executable($config['tube_ffmpeg'])) || $config['tube_youtube'] == true)) ? true : false,
	'S_ITEM_VIEW'			=> true,
	'U_TUBE_ADD'			=> append_sid("{$tube_path}video_add.$phpEx", "mode=addvideo"),
	'U_TUBE'				=> append_sid("{$tube_path}index.$phpEx"),
	'U_TUBE_COMMENT_ADD'	=> append_sid("{$tube_path}video.$phpEx", "mode=comment&amp;id=" . $id . "&amp;submode=add"),
	'ERROR'					=> $error,
	'L_COMMENT_LENGTH'		=> sprintf($user->lang['COMMENT_LENGTH'], $config['tube_comment_length']),
	'BBCODE_STATUS'			=> ($bbcode_status) ? sprintf($user->lang['BBCODE_IS_ON'], '<a href="' . append_sid("{$phpbb_root_path}faq.$phpEx", 'mode=bbcode') . '">', '</a>') : sprintf($user->lang['BBCODE_IS_OFF'], '<a href="' . append_sid("{$phpbb_root_path}faq.$phpEx", 'mode=bbcode') . '">', '</a>'),
	'IMG_STATUS'			=> ($img_status) ? $user->lang['IMAGES_ARE_ON'] : $user->lang['IMAGES_ARE_OFF'],
	'FLASH_STATUS'			=> ($flash_status) ? $user->lang['FLASH_IS_ON'] : $user->lang['FLASH_IS_OFF'],
	'SMILIES_STATUS'		=> ($smilies_status) ? $user->lang['SMILIES_ARE_ON'] : $user->lang['SMILIES_ARE_OFF'],
	'URL_STATUS'			=> ($bbcode_status && $url_status) ? $user->lang['URL_IS_ON'] : $user->lang['URL_IS_OFF'],
	'S_BBCODE_ALLOWED'		=> $bbcode_status,
	'S_SMILIES_ALLOWED'		=> $smilies_status,
	'S_LINKS_ALLOWED'		=> $url_status,
	'S_BBCODE_IMG'			=> $img_status,
	'S_BBCODE_URL'			=> $url_status,
	'S_BBCODE_FLASH'		=> $flash_status,
	'S_BBCODE_QUOTE'		=> $quote_status,
));

if ($config['tube_disabled'] == false)
{
	if (!isset($user->lang['TUBE_COPYRIGHT']) || (trim($user->lang['TUBE_COPYRIGHT']) == '') || $user->lang['TUBE_COPYRIGHT'] != $user->lang['TUBE_COPYRIGHT_CHECK'])
	{
		trigger_error($user->lang['TUBE_REPLACE_COPYRIGHT'], E_USER_NOTICE);
	exit;
	}
	switch($mode)
	{
		case "comment":	
			switch($submode)
			{
				case "add":
					if ($submit)
					{
						$comment = request_var('message', '', true);
						$comment_text = $comment;
						$text = utf8_normalize_nfc(request_var('message', '', true));
						$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
						$allow_bbcode = $allow_urls = $allow_smilies = true;
						generate_text_for_storage($text, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
                        $comment_username = request_var('username', '', true);
						$comment_username_req = false;
						if ($user->data['user_id'] == ANONYMOUS)
					    {
						    $comment_username_req = true;
					    }
					    if ($comment_username_req)
					    {
						    if ($comment_username == '')
						    {
							    $submit = false;
							    $message .= (($error) ? '<br />' : '') . $user->lang['MISSING_USERNAME'];
							    $error = true;
						    }
					    }
						if ($comment_text == '')
						{
							$submit = false;
							$message .= (($error) ? '<br />' : '') . $user->lang['MISSING_COMMENT'];
							$error = true;
						}
						if (utf8_strlen($comment_text) > $config['tube_comment_length'])
						{
							$submit = false;
							$message .= (($error) ? '<br />' : '') . $user->lang['COMMENT_TOO_LONG'];
							$error = true;
						}
						$sql_ary = array(
							'comment_item_id'		=> $id,
							'comment_user_id'		=> $user->data['user_id'],
							'comment_username'		=> $user->data['username'],
							'comment_user_ip'		=> $user->ip,
							'comment_time'			=> time(),
							'comment'				=> $text,
							'comment_uid'			=> $uid,
							'comment_bitfield'		=> $bitfield,
							'comment_options'		=> $options,
						);
						if ((!$error) && ($sql_ary['comment'] != ''))
						{
							$db->sql_query('INSERT INTO ' . TUBE_COMMENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));
							$message .= $user->lang['COMMENT_STORED'] . '<br />';
						}
					}

					$meta_info = append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;id=' . $id);
					meta_refresh(3, $meta_info);
					$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
					trigger_error($message);
				break;

				case "edit":
					$comment_data = getCommentData($comment_id);
					$comment = request_var('message', '', true);
					$comment_text = $comment;
					if ($submit)
					{
						$text = utf8_normalize_nfc(request_var('message', '', true));
						$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
						$allow_bbcode = $allow_urls = $allow_smilies = true;
						generate_text_for_storage($text, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

						if ($user->data['user_id'] == ANONYMOUS)
						{
							$submit = false;
							$error .= (($error) ? '<br />' : '') . $user->lang['MISSING_USERNAME'];
						}
						if ($comment_text == '')
						{
							$submit = false;
							$error .= (($error) ? '<br />' : '') . $user->lang['MISSING_COMMENT'];
						}
						if (utf8_strlen($comment_text) > $config['tube_comment_length'])
						{
							$submit = false;
							$error .= (($error) ? '<br />' : '') . $user->lang['COMMENT_TOO_LONG'];
						}
						$sql_ary = array(
							'comment'				=> $text,
							'comment_uid'			=> $uid,
							'comment_bitfield'		=> $bitfield,
							'comment_options'		=> $options,
							'comment_edit_count'	=> $comment_data['comment_edit_count'] + 1,
							'comment_edit_time'		=> time(),
							'comment_edit_user_id'	=> $user->data['user_id'],
						);
						if ((!$error) && ($sql_ary['comment'] != ''))
						{
							$db->sql_query('UPDATE ' . TUBE_COMMENTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE comment_id = ' . (int) $comment_id);
							$message .= $user->lang['COMMENT_STORED'] . '<br />';

							$meta_info = append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;id=' . $id);
							meta_refresh(3, $meta_info);
							$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
							trigger_error($message);
						}
					}
					elseif ($deny)
					{
						$message = $user->lang['EDITED_COMMENT_NOT'] . '<br />';

						$meta_info = append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;id=' . $id);
						meta_refresh(3, $meta_info);
						$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
						trigger_error($message);
					}
					else
					{
						$default_text = $comment_data['comment'];
						decode_message($default_text, $comment_data['uid']);

						$template->assign_vars(array(
							'S_COMMENT_EDIT'				=> true,
							'S_ITEM_VIEW'					=> false,

							'COMMENT_TEXT'					=> $default_text,
							'U_TUBE_COMMENT_EDIT'			=> (!$user->data['is_registered']) ? '' : (($auth->acl_get('m_tube_edit')) ? append_sid("{$tube_path}video.$phpEx", 'mode=comment&amp;submode=edit&amp;comment_id=' . $comment_id . '&amp;id=' . $id) : ''),
						));
					}					
	                $template->set_filenames(array(
						'body'  		=> 'tube/tube_item.html'
					));
					$page_title = $user->lang['TUBE'] . ' &bull; ' . $user->lang['EDIT_COMMENT'];
				break;

				case "delete":
					if ($auth->acl_get('m_tube_delete'))
					{
						$s_hidden_fields = build_hidden_fields(array(
							'item_id'			=> $item_id,
							'comment_id'		=> $comment_id,
							'mode'				=> "comment",
							'submode'			=> "delete",
						));
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . TUBE_COMMENTS_TABLE . " WHERE comment_id ='" . $db->sql_escape($comment_id) . "'";
							$db->sql_query($sql);

							$submit = true;
							$message = $user->lang['DELETED_COMMENT'] . '<br />';
						}
						else
						{
							if (isset($_POST['cancel']))
							{
								$message = $user->lang['DELETED_COMMENT_NOT'] . '<br />';
								$submit = true;
							}
							else
							{
								confirm_box(false, $user->lang['DELETE_COMMENT2'], $s_hidden_fields);
							}
						}
					}
					else
					{
						$submit = false;
						$message = $user->lang['DELETE_NOT_ALLOWED'] . '<br />';
					}

					$meta_info = append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;id=' . $id);
					meta_refresh(3, $meta_info);
					$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
					trigger_error($message);
				break;
			}
		break;

		case "rating":
			$value = request_var('value',0);
			($value > 5) ? $value = 5 : '';
			($value < 0) ? $value = 0 : '';
			$rate_count = countRatings($id);
			if ($rate_count == 0)
			{
				$data = array(
					'item_id'	=> $id,
					'user_id'	=> $user->data['user_id'],
					'rating'	=> $value,
				);
				$db->sql_query('INSERT INTO ' . TUBE_RATINGS_TABLE . $db->sql_build_array('INSERT', $data));
				$message = $user->lang['TUBE_RATING_SUCCESS'];
			}
			else
			{
				$message = $user->lang['TUBE_RATING_FAILURE'];
			}

			$meta_info = append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;id=' . $id);
			meta_refresh(3, $meta_info);
			$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
			trigger_error($message);
		break;
        
		case "item":

		switch($submode)
			{
			default:
			if (!$auth->acl_get('u_tube_view'))
			{
				login_box(append_sid("./tube/video.$phpEx"), $user->lang['LOGIN_EXPLAIN_TUBE']);
			}
			if ($user->data['is_bot'])
			{
				redirect(append_sid("{$phpbb_root_path}video.$phpEx"));
			}
			$db->sql_query('UPDATE ' . TUBE_ITEMS_TABLE . " SET views = views+1 WHERE item_id = '" . $db->sql_escape($id) . "'");
			$cache->destroy('sql', TUBE_ITEMS_TABLE);
			get_comment_info($id,$sort_order,$comment_limit,$start);
			$item_info = get_item_info($id);
			$cat_info = get_category_info($item_info['category_id']);
			$user_info = get_user_info($item_info['user_id']); //fix in 2.1
			$template->assign_vars(array(
				'U_CATEGORY'		=> append_sid("{$tube_path}video_category.$phpEx", "mode=category&amp;id=" . $item_info['category_id']),
				'CATEGORY'			=> $cat_info['title'],
				'U_ITEM'			=> append_sid("{$tube_path}video.$phpEx", "mode=item&amp;id=" . $id),
// HD FUDGE		'FILE'				=> ($item_info['youtube'] != '') ? 'http://phpbb.unstable.org.uk/tube/videos/test.php?v=' . $id : $id . ".flv",
				'FILE'				=> ($item_info['youtube'] != '') ? $item_info['youtube'] :  $phpbb_root_path . "videos/" . $id . ".flv",
				'IMAGE'				=> ($item_info['youtube'] != '') ? $item_info['image'] : $item_info['image'],
				'ITEM'				=> $item_info['title'],
				'DESCRIPTION'		=> $item_info['description'],
				'VIEWS'				=> $item_info['views'],
				'DATE'				=> date('d/m/Y',$item_info['date']),
				'USER'				=> get_username_string('full', $item_info['user_id'], $user_info['username'], $user_info['user_colour']),
				'DURATION'			=> str_pad(intval(($item_info['duration'] / 60) % 60), 2, "0", STR_PAD_LEFT) . ':' . str_pad(intval($item_info['duration'] % 60), 2, "0", STR_PAD_LEFT),
				'RATING'			=> get_rating($id, true, true),
	    		'U_DELETE'		    => (!$user->data['is_registered']) ? '' : (($auth->acl_get('m_tube_delete')) ? append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;submode=delete&amp;id=' . $id ) : ''),
                'U_EDIT'			=> (!$user->data['is_registered']) ? '' : (($auth->acl_get('m_tube_edit')) ? append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;submode=edit&amp;id=' . $id ) : ''),
				'S_TUBE_LOGO'		=> ($config['tube_logo_enabled']) ? true : false,
				'TUBE_LOGO'			=> $config['tube_logo'],
				'UPLOAD_OPTION'		=> get_uploadoption_img($id),
		//old   'BBCODE_INFO'		=> '[Ourtube]' . $id . '[/Ourtube]',
				'BBCODE_INFO'		=> ($item_info['youtube'] != '') ? '[Ourtube]' . $item_info['youtube'] . '[/Ourtube]':  '[Ourtube]' . generate_board_url() . "/tube/videos/" . $id . ".flv" . '[/Ourtube]',
				'ITEM_COMMENTS'		=> countComments($id),
				'SORT_ASC'			=> ($sort_order == 'ASC') ? true : false,
				'PAGE_NUMBER'		=> on_page(countComments($id), $comment_limit, $start),
				'PAGINATION'		=> generate_pagination(append_sid("{$tube_path}video.$phpEx", "mode=item&amp;id=" . $id), countComments($id), $comment_limit, $start, true),
			));
			$template->assign_block_vars('navlinks', array(
				'U_VIEW_FORUM'  	=> append_sid("{$tube_path}index.$phpEx"),
				'FORUM_NAME'    	=> $user->lang['TUBE'],
			));
			$template->assign_block_vars('navlinks', array(
				'U_VIEW_FORUM'  	=> append_sid("{$tube_path}video_category.$phpEx", "mode=category&amp;id=" . $item_info['category_id']),
				'FORUM_NAME'    	=> $cat_info['title'],
			));
			$template->assign_block_vars('navlinks', array(
				'U_VIEW_FORUM'  	=> append_sid("{$tube_path}video.$phpEx", "mode=item&amp;id=" . $id),
				'FORUM_NAME'    	=> $item_info['title'],
			));
			$template->set_filenames(array(
				'body'  		=> 'tube/tube_item.html'
			));
			$page_title = $user->lang['TUBE'] . ' &bull; ' . $cat_info['title'] . ' &bull; ' . $item_info['title'];
			break;
			
			case "edit":
			if ($auth->acl_get('m_tube_edit'))
				{
						$sql = 'SELECT *
							FROM ' . TUBE_ITEMS_TABLE . "
							WHERE item_id = '" . $item_id . "'";
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						
						$s_hidden_fields = build_hidden_fields(array(
							'item_id'			=> $item_id,
							'comment_id'		=> $comment_id,
							'mode'				=> "item",
							'submode'			=> "edit",
						));
					$item_info = get_item_info($id);
					$cat_info = get_category_info($item_info['category_id']);
					if ($submit)
					{
						$text = utf8_normalize_nfc(request_var('message', '', true));
						$text2 = utf8_normalize_nfc(request_var('title', '', true));
						$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
						$allow_bbcode = $allow_urls = $allow_smilies = true;
						generate_text_for_storage($text, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

						$sql_ary = array(
							'description'			=> $text,
							'title'					=> $text2,
						);
						if ((!$error) && ($sql_ary['description'] != '') && ($sql_ary['title'] != ''))
						{
							$db->sql_query('UPDATE ' . TUBE_ITEMS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE item_id = '" . $id . "'");
							$cache->destroy('sql', TUBE_ITEMS_TABLE);

							$message .= $user->lang['EDIT_VIDEO2'] . '<br />';

							$meta_info = append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;id=' . $id);
							meta_refresh(3, $meta_info);
							$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
							trigger_error($message);
						}
					}
					elseif ($deny)
					{
						$message = $user->lang['EDITED_VIDEO_NOT'] . '<br />';

						$meta_info = append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;id=' . $id);
						meta_refresh(3, $meta_info);
						$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
						trigger_error($message);
					}
					else
					{
						$default_description = $item_info['description'];			
						$default_title = $item_info['title'];

						
						$template->assign_vars(array(
							'S_ITEM_EDIT'			    	=> true,
							'S_ITEM_VIEW'					=> false,

							'ITEM_TITLE'					=> $default_title,
							'ITEM_DESCRIPTION'				=> $default_description,
							'U_TUBE_ITEM_EDIT'			    => (!$user->data['is_registered']) ? '' : (($auth->acl_get('m_tube_edit')) ? append_sid("{$tube_path}video.$phpEx", 'mode=item&amp;submode=edit&amp;id=' . $id) : ''),
						));
					}					
	                $template->set_filenames(array(
						'body'  		=> 'tube/tube_item.html'
					));
					$page_title = $user->lang['TUBE'] . ' &bull; ' . $user->lang['EDIT_VIDEO'];
                }
				else
				{
					$submit = false;
					$message = $user->lang['EDIT_NOT_ALLOWED'] . '<br />';
					trigger_error($message);
				}
		    break;
				
			case "delete":
				if ($auth->acl_get('m_tube_delete'))
					{
					    $sql = 'SELECT *
							FROM ' . TUBE_ITEMS_TABLE . "
							WHERE item_id = '" . $item_id . "'";
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						
						$s_hidden_fields = build_hidden_fields(array(
							'item_id'			=> $item_id,
							'comment_id'		=> $comment_id,
							'mode'				=> "item",
							'submode'			=> "delete",
						));
						if (confirm_box(true))
						{
								$sql = 'SELECT *
									FROM ' . TUBE_ITEMS_TABLE . "
									WHERE item_id = '" . $item_id . "'";
								$result = $db->sql_query($sql);
								$thumb = $phpbb_root_path . 'tube/images/no_thumb.png';
								if (($row['youtube'] == '')&&($row['thumb'] != $thumb))
								{
									if (isset($row['thumb']) && $row['thumb'] != '' && file_exists($row['thumb']))
									{
										unlink($row['thumb']);
									}
									if (isset($row['image']) && $row['image'] != '' && file_exists($row['image']))
									{
										unlink($row['image']);
									}
									if (file_exists($phpbb_root_path . "tube/videos/" . $id . '.flv'))
									{
										unlink($phpbb_root_path . "tube/videos/" . $id . '.flv');
									}
								}
								$db->sql_freeresult($result);
								
								$db->sql_query('DELETE FROM ' . TUBE_ITEMS_TABLE . " WHERE item_id = '" . $id . "'");
								$cache->destroy('sql', TUBE_ITEMS_TABLE);
								$db->sql_query('DELETE FROM ' . TUBE_RATINGS_TABLE . " WHERE item_id = '" . $id . "'");
								$cache->destroy('sql', TUBE_RATINGS_TABLE);
								$db->sql_query('DELETE FROM ' . TUBE_COMMENTS_TABLE . " WHERE comment_item_id = '" . $id . "'");
								$cache->destroy('sql', TUBE_COMMENTS_TABLE);
								
								$submit = true;
							    $message = $user->lang['DELETED_VIDEO'] . '<br />';
						}
						else
						{
							if (isset($_POST['cancel']))
							{
								$message = $user->lang['DELETED_VIDEO_NOT'] . '<br />';
								$submit = true;
							}
							else
							{
								confirm_box(false, $user->lang['DELETE_VIDEO2'], $s_hidden_fields);
							}
						}
					}
					else
					{
						$submit = false;
						$message = $user->lang['DELETE_NOT_ALLOWED'] . '<br />';
					}

					$meta_info = append_sid("{$tube_path}index.$phpEx");
					meta_refresh(3, $meta_info);
					$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_INDEX'], '<a href="' . $meta_info . '">', '</a>');
					trigger_error($message);
				break;
			}
		break;
    }
}
else
{
	$template->assign_block_vars('navlinks', array(
		'U_VIEW_FORUM'  	=> append_sid("{$tube_path}index.$phpEx"),
		'FORUM_NAME'    	=> $user->lang['TUBE'],
	));
	$template->set_filenames(array(
		'body'				=> 'tube/tube_disable.html'
	));
	$page_title = $user->lang['TUBE'];
}		
// Output the page
page_header($page_title);

$template->set_filenames(array(
	'body' => 'tube/tube_item.html')
);

page_footer();
// Get comment info with, commentposter info from cache
function get_comment_info($item_id,$sort_order,$comment_limit,$start)
{
	global $phpbb_root_path, $tube_path, $user, $db, $auth, $config, $template, $phpEx;

	$sql = 'SELECT * FROM ' . TUBE_COMMENTS_TABLE . "
		WHERE comment_item_id ='" . $db->sql_escape($item_id) . "'
		ORDER BY comment_time $sort_order";
	$result = $db->sql_query_limit($sql,$comment_limit,$start);

	while($comment_info = $db->sql_fetchrow($result))
	{
		$e_user_info = get_user_info($comment_info['comment_edit_user_id']);
		$poster_id = $comment_info['comment_user_id'];
		if (!isset($user_cache[$poster_id]))
		{
		global $config;
			$user_sig = '';
			$user_info = get_user_info($poster_id);

			if ($user_info['user_sig'] && $config['allow_sig'] && $user->optionget('viewsigs'))
			{
				$user_sig = generate_text_for_display($user_info['user_sig'], $user_info['user_sig_bbcode_uid'], $user_info['user_sig_bbcode_bitfield'], $user_info['user_options']);
			}
			$user_cache[$poster_id] = array(
				'joined'				=> $user->format_date($user_info['user_regdate']),
				'posts'					=> $user_info['user_posts'],
				'warnings'				=> (isset($user_info['user_warnings'])) ? $user_info['user_warnings'] : 0,
				'from'					=> (!empty($user_info['user_from'])) ? $user_info['user_from'] : '',
				'viewonline'			=> $user_info['user_allow_viewonline'],
				'allow_pm'				=> $user_info['user_allow_pm'],
				'avatar'				=> ($user->optionget('viewavatars')) ? get_user_avatar($user_info['user_avatar'], $user_info['user_avatar_type'], $user_info['user_avatar_width'], $user_info['user_avatar_height']) : '',
				'age'					=> '',
				'sig'			        => '',
				'rank_title'			=> '',
				'rank_image'			=> '',
				'rank_image_src'		=> '',
				'username'				=> $user_info['username'],
				'user_colour'			=> $user_info['user_colour'],
				'online'				=> false,
				'profile'				=> append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=viewprofile&amp;u=$poster_id"),
				'www'					=> $user_info['user_website'],
				'aim'					=> ($user_info['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u=$poster_id") : '',
				'msn'					=> ($user_info['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u=$poster_id") : '',
				'yim'					=> ($user_info['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($comment_info['user_yim']) . '&amp;.src=pg' : '',
				'jabber'				=> ($user_info['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u=$poster_id") : '',
				'search'				=> ($auth->acl_get('u_search')) ? append_sid("{$phpbb_root_path}search.$phpEx", "author_id=$poster_id&amp;sr=posts") : '',
			);

			get_user_rank($user_info['user_rank'], $user_info['user_posts'], $user_cache[$poster_id]['rank_title'], $user_cache[$poster_id]['rank_image'], $user_cache[$poster_id]['rank_image_src']);

			if (!empty($user_info['user_allow_viewemail']) || $auth->acl_get('a_email'))
			{
			global $config;
				$user_cache[$poster_id]['email'] = ($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u=$poster_id") : (($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $user_info['user_email']);
			}
			else
			{
				$user_cache[$poster_id]['email'] = '';
			}

			if (!empty($user_info['user_icq']))
			{
				$user_cache[$poster_id]['icq'] = 'http://www.icq.com/people/webmsg.php?to=' . $user_info['user_icq'];
				$user_cache[$poster_id]['icq_status_img'] = '<img src="http://web.icq.com/whitepages/online?icq=' . $user_info['user_icq'] . '&amp;img=5" width="18" height="18" alt="" />';
			}
			else
			{
				$user_cache[$poster_id]['icq_status_img'] = '';
				$user_cache[$poster_id]['icq'] = '';
			}
		}

		//fix 2.1
		$template->assign_block_vars('commentrow', array(
			'POST_AUTHOR_FULL'		=> get_username_string('full', $comment_info['comment_user_id'], $comment_info['comment_username'], $user_info['user_colour']),
            'POST_AUTHOR'			=> get_username_string('full', $comment_info['comment_user_id'], $user_info['username'], $user_info['user_colour']),			
			'POST_AUTHOR_COLOUR'	=> get_username_string('colour', $comment_info['comment_user_id'], $comment_info['comment_username'], $user_info['user_colour']),
			'U_POST_AUTHOR'			=> get_username_string('profile', $comment_info['comment_user_id'], $comment_info['comment_username'], $user_info['user_colour']),
			
			'TIME'					=> $user->format_date($comment_info['comment_time'], false, true),
			'TEXT'					=> generate_text_for_display($comment_info['comment'], $comment_info['comment_uid'], $comment_info['comment_bitfield'], $comment_info['comment_options']),

			'SIGNATURE'		    	=> $user_cache[$poster_id]['sig'],
			'RANK_TITLE'			=> $user_cache[$poster_id]['rank_title'],
			'RANK_IMG'				=> $user_cache[$poster_id]['rank_image'],
			'RANK_IMG_SRC'			=> $user_cache[$poster_id]['rank_image_src'],
			'POSTER_JOINED'			=> $user_cache[$poster_id]['joined'],
			'POSTER_POSTS'			=> $user_cache[$poster_id]['posts'],
			'POSTER_FROM'			=> $user_cache[$poster_id]['from'],
			'POSTER_AVATAR'			=> $user_cache[$poster_id]['avatar'],
			'POSTER_WARNINGS'		=> $user_cache[$poster_id]['warnings'],
			'POSTER_AGE'			=> $user_cache[$poster_id]['age'],
			'U_PROFILE'				=> $user_cache[$poster_id]['profile'],
			'U_SEARCH'				=> $user_cache[$poster_id]['search'],
			'U_EMAIL'				=> $user_cache[$poster_id]['email'],
			'U_WWW'					=> $user_cache[$poster_id]['www'],
			'U_ICQ'					=> $user_cache[$poster_id]['icq'],
			'U_AIM'					=> $user_cache[$poster_id]['aim'],
			'U_MSN'					=> $user_cache[$poster_id]['msn'],
			'U_YIM'					=> $user_cache[$poster_id]['yim'],
			'U_JABBER'				=> $user_cache[$poster_id]['jabber'],
			'DELETE_IMG'		=> $user->img('icon_post_delete', 'DELETE_COMMENT'),
			'EDIT_IMG'			=> $user->img('icon_post_edit', 'EDIT_COMMENT'),
			'INFO_IMG'			=> $user->img('icon_post_info', 'IP'),

			'EDIT_COUNT'			=> $comment_info['comment_edit_count'],
			'EDIT_INFO'				=> sprintf($user->lang['COMMENT_REVISIONS_INFO'], get_username_string('full', $e_user_info['user_id'], $e_user_info['username'], $e_user_info['user_colour']), $user->format_date($comment_info['comment_edit_time']), $comment_info['comment_edit_count']),
			'U_DELETE'				=> (!$user->data['is_registered']) ? '' : (($auth->acl_get('m_tube_delete')) ? append_sid("{$tube_path}video.$phpEx", 'mode=comment&amp;submode=delete&amp;comment_id=' . $comment_info['comment_id'] . '&amp;id=' . $comment_info['comment_item_id']) : ''),
			'U_EDIT'				=> (!$user->data['is_registered']) ? '' : (($auth->acl_get('m_tube_edit')) ? append_sid("{$tube_path}video.$phpEx", 'mode=comment&amp;submode=edit&amp;comment_id=' . $comment_info['comment_id'] . '&amp;id=' . $comment_info['comment_item_id']) : ''),
			'U_INFO'				=> ($auth->acl_get('a_')) ? append_sid("{$tube_path}includes/mcp.$phpEx", 'mode=whois&amp;ip=' . $comment_info['comment_user_ip']) : '',
		));
	}
	$db->sql_freeresult($result);
			$template->assign_vars(array(
			'DELETE_IMG'		=> $user->img('icon_post_delete', 'DELETE_COMMENT'),
			'EDIT_IMG'			=> $user->img('icon_post_edit', 'EDIT_COMMENT'),
			'INFO_IMG'			=> $user->img('icon_post_info', 'IP'),
			'MINI_POST_IMG'		=> $user->img('icon_post_target_unread', 'COMMENT'),
			'PROFILE_IMG'		=> $user->img('icon_user_profile', 'READ_PROFILE'),
			'SEARCH_IMG' 		=> $user->img('icon_user_search', 'SEARCH_USER_POSTS'),
			'PM_IMG' 			=> $user->img('icon_contact_pm', 'SEND_PRIVATE_MESSAGE'),
			'EMAIL_IMG' 		=> $user->img('icon_contact_email', 'SEND_EMAIL'),
			'WWW_IMG' 			=> $user->img('icon_contact_www', 'VISIT_WEBSITE'),
			'ICQ_IMG' 			=> $user->img('icon_contact_icq', 'ICQ'),
			'AIM_IMG' 			=> $user->img('icon_contact_aim', 'AIM'),
			'MSN_IMG' 			=> $user->img('icon_contact_msnm', 'MSNM'),
			'YIM_IMG' 			=> $user->img('icon_contact_yahoo', 'YIM'),
			'JABBER_IMG'		=> $user->img('icon_contact_jabber', 'JABBER') ,
			'GALLERY_IMG'		=> $user->img('icon_contact_gallery', 'PERSONAL_ALBUM'),
		));
}
// Get category info
function get_category_info($category_id)
{
	global $db, $phpEx;

	$sql = 'SELECT * FROM ' . TUBE_CATEGORIES_TABLE . '
		WHERE category_id = ' . $category_id;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	//fix 2.1
	if (!$row)
	{
	    meta_refresh(3, append_sid("{$phpbb_root_path}{$tube_path}index.$phpEx"));
		trigger_error('VIDEO_NOT_EXIST');
	}
	return $row;
}
function get_rating($id, $votes = FALSE, $link = FALSE)
{
	global $phpbb_root_path, $user, $db, $phpEx;

	$sql = 'SELECT COUNT(item_id), SUM(rating)
		FROM ' . TUBE_RATINGS_TABLE . "
		WHERE item_id = '" . $db->sql_escape($id) . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	if ($row['COUNT(item_id)'] == 0)
	{
		$value = 0;
		$count = 0;
	}
	else
	{
		$value = $row['SUM(rating)'] / $row['COUNT(item_id)'];
		$count = $row['COUNT(item_id)'];
	}
	$rating = '';
	for ($i = 1; $i <= 5; $i++)
	{ 
	global $tube_path;
		$prepend = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? '<a href="' . append_sid("{$tube_path}video.$phpEx", "mode=rating&amp;id=" . $id . "&amp;value=" . $i) . '">' : '';
		if ($value >= 1)
		{
			$append = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? 'onmouseover="this.src=\'images/ratings/on.gif\'" onmouseout="this.src=\'images/ratings/full.gif\'" /></a>' : '/>';
			$rating .= $prepend . '<img src="images/ratings/full.gif" alt="' . $i . '" ' . $append;
		}
		else if ($value >= 0.5)
		{
			$append = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? 'onmouseover="this.src=\'images/ratings/on.gif\'" onmouseout="this.src=\'images/ratings/half.gif\'" /></a>' : '/>';
			$rating .= $prepend . '<img src="images/ratings/half.gif" alt="' . number_format($i + $value,2) . '" ' . $append;
		}
		else
		{
			$append = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? 'onmouseover="this.src=\'images/ratings/on.gif\'" onmouseout="this.src=\'images/ratings/off.gif\'" /></a>' : '/>';
			$rating .= $prepend . '<img src="images/ratings/off.gif" alt="' . (($value > 0) ? number_format($i + $value,2) : '-') . '" ' . $append;
		}
		$value--;
	}
	$rating .= ($votes == TRUE) ? sprintf($user->lang['TUBE_RATING_INFO'], $count) : '';

	return $rating;
}
// Count rates of an item
function countRatings($item_id)
{
	global $db, $user;

	$sql = 'SELECT COUNT(*) as num_rates
		FROM ' . TUBE_RATINGS_TABLE . "
		WHERE item_id = '" . $db->sql_escape($item_id) . "' AND user_id = '" . $user->data['user_id'] . "'";
	$result = $db->sql_query($sql);
	$total_rates = $db->sql_fetchfield('num_rates');
	$db->sql_freeresult($result);

	return $total_rates;
}
// Get the comment data
function getCommentData($comment_id)
{
	global $db;

	$sql = 'SELECT *
		FROM ' . TUBE_COMMENTS_TABLE . '
		WHERE comment_id = ' . $comment_id;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row;
}
?>