<?php
/**
*
* @package phpBB3
* @version $Id: video_category.php
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './../';
$tube_path = $phpbb_root_path . 'tube/';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

include($tube_path . 'tube_functions.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/tube');

// Setup specific vars
$mode = request_var('mode','');
$id = request_var('id','');
$start = request_var('start',0);
$error = $message = NULL;

$template->assign_vars(array(
    'S_TUBE_ADD'			=> ($auth->acl_get('u_tube_add') && (($config['tube_upload'] == true && $config['tube_ffmpeg'] != '' && is_executable($config['tube_ffmpeg'])) || $config['tube_youtube'] == true)) ? true : false,
	'S_ITEM_VIEW'			=> true,
	'U_TUBE_ADD'			=> append_sid("{$tube_path}video_add.$phpEx", "mode=addvideo"),
	'U_TUBE'				=> append_sid("{$tube_path}index.$phpEx"),
	'ERROR'					=> $error,
));

if ($config['tube_disabled'] == false)
{
	if (!isset($user->lang['TUBE_COPYRIGHT']) || (trim($user->lang['TUBE_COPYRIGHT']) == '') || $user->lang['TUBE_COPYRIGHT'] != $user->lang['TUBE_COPYRIGHT_CHECK'])
	{
		trigger_error($user->lang['TUBE_REPLACE_COPYRIGHT'], E_USER_NOTICE);
	exit;
	}
	switch($mode)
	{  
		case "category":
			if (!$auth->acl_get('u_tube_view'))
			{
				login_box(append_sid("./tube/index.$phpEx"), $user->lang['LOGIN_EXPLAIN_TUBE']);
			}
			if ($user->data['is_bot'])
			{
				redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
			}
			$cat_info = get_category_info($id);
			$category = $cat_info['title'];
			$x = $y = 0;
			$total_items = countItems($id);
			$num_videos = 12;
			get_tabitems_order($id,$start,$num_videos,'item','date DESC');
			make_tabs($id);
			$template->assign_vars(array(
				'U_CATEGORY'		=> append_sid("{$tube_path}video_category.$phpEx", "mode=category&amp;id=" . $id),
				'CATEGORY'			=> $category,
				'PAGINATION'		=> generate_pagination(append_sid("{$tube_path}video_category.$phpEx", 'mode=category&amp;id=' . $id), $total_items, $num_videos, $start),
				'PAGE_NUMBER'		=> on_page($total_items, $num_videos, $start),
			));
			$template->assign_block_vars('navlinks', array(
				'U_VIEW_FORUM'  	=> append_sid("{$tube_path}index.$phpEx"),
				'FORUM_NAME'    	=> $user->lang['TUBE'],
			));
			$template->assign_block_vars('navlinks', array(
				'U_VIEW_FORUM'  	=> append_sid("{$tube_path}video_category.$phpEx", "mode=category&amp;id=" . $id),
				'FORUM_NAME'    	=> $category,
			));
			$template->set_filenames(array(
				'body'  			=> 'tube/tube_category.html'
			));
			$page_title = $user->lang['TUBE'] . ' &bull; ' . $category;
		break;
    }
}
else
{
	$template->assign_block_vars('navlinks', array(
		'U_VIEW_FORUM'  	=> append_sid("{$tube_path}video_add.$phpEx"),
		'FORUM_NAME'    	=> $user->lang['TUBE'],
	));
	$template->set_filenames(array(
		'body'				=> 'tube/tube_disable.html'
	));
	$page_title = $user->lang['TUBE'];
}
// Output the page
page_header($page_title);

$template->set_filenames(array(
	'body' => 'tube/tube_category.html')
);

page_footer();
// Get category info
function get_category_info($category_id)
{
	global $db, $phpEx, $tube_path;

	$sql = 'SELECT * FROM ' . TUBE_CATEGORIES_TABLE . '
		WHERE category_id = ' . $category_id;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	//fix 2.1
	if (!$row)
	{
	    meta_refresh(3, append_sid("{$tube_path}index.$phpEx"));
		trigger_error('CATEGORY_NOT_EXIST');
	}
	return $row;
}		
?>		